/* glcd_routines.h
*
*/

// Display size
#define GLCD_MAXX 192
#define GLCD_MAXY 64

// KS0108 commands
#define GLCD_SET_LIGHT 3
#define GLCD_DIM_LIGHT_ON 4
#define GLCD_DIM_LIGHT_OFF 5
#define GLCD_VERBOSE_ON 7
#define GLCD_VERBOSE_OFF 8
#define GLCD_SET_AUTOSCROLL_ON 9
#define GLCD_SET_AUTOSCROLL_OFF 10
#define GLCD_CLEAR_SCREEN 15
#define GLCD_SET_PIXEL 16
#define GLCD_DRAW_RECTANGLE 23
#define GLCD_DRAW_FILLED_RECTANGLE 24
#define GLCD_SET_CURSOR 50
#define GLCD_SET_FONT 51
#define GLCD_DRAW_CHAR 32
#define GLCD_DRAW_STRING 33
#define GLCD_DRAW_CENTER_STR 34
#define GLCD_DRAW_DEC 35
#define GLCD_DRAW_SDEC 36
#define GLCD_DRAW_LINE 17
#define GLCD_DRAW_DOTTED_VER_LINE 19
#define GLCD_DRAW_DOTTED_HOR_LINE 20

// Functions
void glcd_set_light(const uint8_t light_level);
void glcd_set_dim(void);
void glcd_clear_dim(void);
void glcd_clear_screen(void);
void glcd_set_pixel(const uint8_t x, const uint8_t ly, const uint8_t mode);
void glcd_draw_rectangle(const uint8_t x_start, const uint8_t y_start, const uint8_t x_end, const uint8_t y_end, const uint8_t mode);
void glcd_draw_filled_rectangle(const uint8_t x_start, const uint8_t y_start, const uint8_t x_end, const uint8_t y_end, const uint8_t mode);
void glcd_draw_dec(const uint16_t dec, const uint8_t len, const uint8_t dec_places);
void glcd_draw_sdec(const int16_t dec, const uint8_t len, const uint8_t dec_places);
void glcd_draw_char(const uint8_t my_char);
void glcd_draw_string(const char *string);
void glcd_draw_pgm_string(const char *my_str);
void glcd_draw_center_str(char *string);
void glcd_draw_pgm_center_str(const char *my_str);
void glcd_set_cursor(const uint8_t x_pos, const uint8_t y_pos);
void glcd_set_font(const uint8_t font);
void glcd_draw_line(const uint8_t x_start, const uint8_t y_start, const uint8_t x_end, const uint8_t y_end, const uint8_t mode);
void glcd_draw_dotted_hor_line(const uint8_t y_pos, const uint8_t x_start, const uint8_t x_end, const uint8_t spacing, const uint8_t mode);
void glcd_draw_dotted_ver_line(const uint8_t x_pos, const uint8_t y_start, const uint8_t y_end, const uint8_t spacing, const uint8_t mode);
void glcd_set_verbose(const uint8_t verbose_status);
void glcd_set_autoscroll(const uint8_t scroll_status);
void glcd_dummy(void);

